.. _rascil:

******
RASCIL
******

The `RASCIL <https://ska-telescope.gitlab.io/external/rascil/>`_ pipelines are presented as shell scripts and input files.
Instead of the shell scripts, once can also use Nextflow to run the pipeline (see below).

RASCIL runs within the following docker image::

    artefact.skao.int/rascil-full:0.3.0

Newer docker images are being released, and the published version tags can be found at
https://artefact.skao.int/#browse/browse:docker-all:v2%2Frascil-full%2Ftags

Note: from version 0.3.0 and newer, RASCIL is installed as a package into the docker images and
the repository is not cloned anymore. Hence, every python script within the image has to be
called with the ``-m`` switch in the following format, e.g.:

.. code-block::

    python -m rascil.apps.rascil_advise <args>

The Functional Test
###################

For comparison purposes, the RASCIL pipelines run the same functional test as the :ref:`yandasoft` ones.

The input data
**************

The measurement set for it is included in `pipelines/yandasoft/data/functest.ms`. It is a small,
8 channel ASKAP simulation.

Running the test locally
************************

Bash scripts
^^^^^^^^^^^^

The provided bash scripts need to be run within the ``rascil-full`` docker container,
or RASCIL has to be `installed <https://ska-telescope.gitlab.io/external/rascil/RASCIL_install.html>`_ on the local machine.

`pipelines/rascil/bash/functest.sh` provides an example flow of RASCIL pipelines. It starts with
running `rascil_advise <https://ska-telescope.gitlab.io/external/rascil/apps/rascil_advise.html>`_ to
provide imaging parameters for the input CASA MeasurementSet. Followed by
`rascil_imager <https://ska-telescope.gitlab.io/external/rascil/apps/rascil_imager.html>`_ to create
FITS image files. And finally it runs
`imaging_qa <https://ska-telescope.gitlab.io/external/rascil/apps/imaging_qa.html>`_,
which produces important statistics and diagnostics plots to verify the "correctness" of the restored
and residual images generated by ``rascil_imager``.

Each commandline app uses configuration files stored in `pipelines/rascil/config/`. Alternatively,
one can run the commands by providing the input parameters together with the CLI command. Examples of
such runs are `pipelines/rascil/bash/rascil-imager.sh` and `pipelines/rascil/bash/imaging_qa.sh`.
A detailed explanation of the CLI arguments for each RASCIL application can be found at the links above.

Each bash script assumes that RASCIL is installed as a package into your environment.

Nextflow pipeline
^^^^^^^^^^^^^^^^^

The full imaging and qa pipeline can be deployed via `Nextflow <https://www.nextflow.io/docs/latest/basic.html>`_.
If you have RASCIL installed locally, you should be able to just run the workflow from `pipelines/rascil/nextflow`
(assuming Nextflow is also `installed <https://www.nextflow.io/docs/latest/getstarted.html#installation>`_
in this directory):

.. code-block:: 

    nextflow run rascil_imager.nf

The RASCIL Nextflow pipeline does not use a custom Nextflow configuration file by default,
there is no need to set up a `local.cfg` file and pass that into the command like the Yandasoft pipeline does.
If you need to change to configuration, you can update the provided `nextflow.config` file, which is automatically
used by Nextflow.

The outputs of the ``imaging_qa`` tool will be saved in `pipelines/rascil/nextflow/products`. A more detailed explanation
of the Nextflow processes can be found below.


Running the test in GitLab CI
*****************************

The ``test-rascil`` job in `.gitlab-ci.yml` runs the Nextflow version of the RASCIL pipelines using
the test MeasurementSet.

It pulls the most recent version of the ``rascil-full`` docker image (0.3.0 at time of writing).
It installs JAVA, a prerequisite of Nextflow, and installs Nextflow within the `pipelines/racil/nextflow` directory.
After running the pipelines, it copies the outputs of the ``imaging_qa`` tool into the artifact directory.

The Nextflow pipeline
*********************

Nextflow-related files can be found in `pipelines/rascil/nextflow`. `nextflow.config` contains the
basic configuration of executors. Currently, it only contains one option, to run Nextflow with singularity,
however, this is a conditional setting, and by default, it will run locally in the local environment.
When run in GitLab CI, it uses the docker image provided by the CI job as its local environment.

The more important file is `rascil_imager.nf`, which contains the Nextflow process definitions.
It runs three processes::

    - imager
    - qa
    - test

The ``imager`` process
^^^^^^^^^^^^^^^^^^^^^^

The inputs for this process are provided through the ``datafile`` and ``imager_config`` channels.
The first one contains the input MeasurementSet, while the second contains the configuration file
for `rascil_imager`. The configuration file can be found at `pipelines/rascil/config/rascil-imager.in`.

The output files of the imager, used by the second process, are the restored and residual images,
both passed into another two channel, in order to communicate them to the second process.

The ``qa`` process
^^^^^^^^^^^^^^^^^^^^^^^

The ``qa`` process takes as an input the restored and residual FITS images produced by
the first (``imager``) process, as well as an input configuration file for the ``imaging_qa`` code.
The configuration file can be found at `pipelines/rascil/config/imaging_qa.in`.

It outputs various figures, CSV files, HDF files, and log files, all of which are transferred into the
`products` directory, generated on the fly in the directory where Nextflow was executed from. These final
products can then be inspected to draw conclusions on the correctness of the imaging pipeline.

The ``test`` process
^^^^^^^^^^^^^^^^^^^^

This process uses the restored image from the ``qa`` process and performs a simple check.
`rascil_image_check <https://ska-telescope.gitlab.io/external/rascil/apps/rascil_image_check.html>`_ is
called with ``--stat max --min 0.495 --max 0.505`` parameters. With this set up, we test and verify that
the brightest source in the restored image is 1 Jy. The definition of the stokes I value in
RASCIL is ``I=0.5*(XX+YY)``, hence the min-max range is not around 1, but around 0.5.
This process matches the test stage of the YANDASoft Nextflow pipeline.

(See :ref:`yandasoft` for the Nextflow pipeline set up for YANDASoft, which explains
their processes in more detail, some of which also applies to the RASCIL Nextflow pipeline.)
